## mia 2.4.7

=== CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

PROJECT("mia")

# now need OBJECT libraries 
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.8 FATAL_ERROR)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0012 NEW)
  IF(${CMAKE_VERSION} VERSION_GREATER 3.0.0) 
    cmake_policy(SET CMP0042 NEW)
  ENDIF()
endif(COMMAND cmake_policy)

# This test is added for the Ninja generator, since it 
# has problems with relinking when installing 
# 
STRING(COMPARE EQUAL "${CMAKE_SYSTEM_NAME}" "Linux" SYSTEM_IS_LINUX)
IF(${SYSTEM_IS_LINUX})
  SET(CMAKE_EXECUTABLE_FORMAT "ELF")
ENDIF()

include(FindPkgConfig)
include(CheckCXXSourceCompiles)

# Making releases:
#   MICRO_VERSION += 1;
#   INTERFACE_AGE += 1;
#   BINARY_AGE += 1;
# if any functions have been added, set INTERFACE_AGE to 0.
# if backwards compatibility has been broken,
# set BINARY_AGE and INTERFACE_AGE to 0.


SET(VENDOR "Gert Wollny")
SET(PACKAGE_NAME "mia")
SET(MAJOR_VERSION 2)
SET(MINOR_VERSION 4)
SET(MICRO_VERSION 7)
SET(INTERFACE_AGE 1)
SET(BINARY_AGE    1)

#
#SET(CMAKE_BUILD_WITH_INSTALL_RPATH 1)

SET(PACKAGE_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${MICRO_VERSION}")
SET(VERSION "${MAJOR_VERSION}.${MINOR_VERSION}")
SET(MIA_NAME "${PACKAGE_NAME}-${VERSION}")
SET(prefix ${CMAKE_INSTALL_PREFIX})
SET(PLUGIN_OUTPUT "${CMAKE_BINARY_DIR}/plugins")

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

MATH(EXPR MIA_CURRENT "${MICRO_VERSION} - ${BINARY_AGE}")
SET(MIA_REVISION ${INTERFACE_AGE})
MATH(EXPR MIA_AGE "${BINARY_AGE} - ${INTERFACE_AGE}")

SET(LIBRARY_SOVERSION_INFO "${MIA_CURRENT}")
SET(LIBRARY_VERSION_INFO "${MIA_CURRENT}.${MIA_AGE}.${MIA_REVISION}")

OPTION(STRICT_DEPENDECIES "require that all requested optinal dependencies are availabe" FALSE)
OPTION(ALWAYS_CREATE_DOC "Create all documentation during the normal build process (normally you need to run 'make doc')" TRUE)
OPTION(BUILD_EXAMPLES "Build example plug-ins and programs" FALSE)
OPTION(ENABLE_DEBUG_MESSAGES "Enable debug and trace outputs" TRUE)
OPTION(ENABLE_COVERAGE "Enable code coverage tests" FALSE)
OPTION(DISABLE_PROGRAMS "Don't build the programs nor documentation (only for testing purposes)" FALSE)
OPTION(MIA_CREATE_USERDOC "Enable creation of html user documentation" TRUE)
OPTION(MIA_ENABLE_TESTING "Enable compiling and running the test suite" TRUE)



INCLUDE(GNUInstallDirs)

INCLUDE (CheckIncludeFiles)
INCLUDE (TestBigEndian)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/macros.cmake)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/pluginmacro.cmake)
INCLUDE (CheckTypeSize)
INCLUDE (CheckIncludeFileCXX)

include(CheckCXXCompilerFlag)


MESSAGE(STATUS "Compiler is ${CMAKE_CXX_COMPILER_ID} version ${CMAKE_CXX_COMPILER_VERSION}")

IF (((${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU") AND
      (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5.3.0)) OR
    ((${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang") AND
      (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 3.3.0)))
  MESSAGE(STATUS "Compiler  has full c++11 support")

  # g++ >= 6.0 sets std=c++14 by default
  IF ((${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU") AND
      (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0.0))  
    SET(CXX_11_FLAG "-std=c++11")
  ENDIF()
  
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  ${CXX_11_FLAG} -fvisibility=hidden")
ELSE()
  CHECK_CXX_COMPILER_FLAG("-std=c++11" HAS_GNU_CXX11_FLAG)
  IF(HAS_GNU_CXX11_FLAG)
    SET(CXX_11_FLAG "-std=c++11")
  ELSE(HAS_GNU_CXX11_FLAG)
    CHECK_CXX_COMPILER_FLAG("-std=c++0x" HAS_GNU_CXX0X_FLAG)
    IF(HAS_GNU_CXX0X_FLAG)
      SET(CXX_11_FLAG "-std=c++0x")
    ELSE(HAS_GNU_CXX0X_FLAG)
      MESSAGE(WARNING "Don't know how to enable C++11, if you are lucky, they are enabled by default")
    ENDIF(HAS_GNU_CXX0X_FLAG)
  ENDIF(HAS_GNU_CXX11_FLAG)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  ${CXX_11_FLAG} -fvisibility=hidden")
  INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkCpp0xAuto.cmake)
  INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkCpp0xLambda.cmake)
  IF(NOT "${CXX_HAS_CXX_0X_AUTO}" OR NOT CXX_HAS_CXX_0X_LAMBDA)
    MESSAGE(FATAL_ERROR 
      "This source code requires the C++0x auto type and lambda features. "
      "If your compiler is supposed to support this feature, "
      "please enable the appropriate flags and delete the CMakeCache.txt file before "
      "re-running cmake.\n"
      "For g++ >= 4.8 this is '-std=c++0x' ")
  ENDIF(NOT "${CXX_HAS_CXX_0X_AUTO}" OR NOT CXX_HAS_CXX_0X_LAMBDA)
ENDIF()

# older versions of g++ libstdc++ don't implement regex sufficiently good
# to be useful
IF ((${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU") AND
    (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5.3.0))
  SET(MIA_USE_BOOST_REGEX_PRESET FALSE)
ELSE()
  SET(MIA_USE_BOOST_REGEX_PRESET TRUE)
ENDIF()
  
OPTION(MIA_USE_BOOST_REGEX "Use the boost::regex library (instead of c++11 build in) " ${MIA_USE_BOOST_REGEX_PRESET})

IF (ENABLE_COVERAGE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage -O0 -g -DMIA_COVERAGE")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage")
ENDIF()

INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkSSEAttributeVectorCanUseSubscript.cmake)

INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkAltivecEnabled.cmake)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkSSEEnabled.cmake)

ASSERT_SIZE(char 1)
ASSERT_SIZE(short 2)
ASSERT_SIZE(int 4)
ASSERT_SIZE(float 4)
ASSERT_SIZE(double 8)

CHECK_TYPE_SIZE(long LONG_TYPE_SIZE)


IF (${LONG_TYPE_SIZE} EQUAL 8)
  SET(LONG_64BIT TRUE)
ELSE(${LONG_TYPE_SIZE} EQUAL 8)
  SET(LONG_64BIT FALSE)
ENDIF(${LONG_TYPE_SIZE} EQUAL 8)

TEST_BIG_ENDIAN(WORDS_BIGENDIAN)
CHECK_INCLUDE_FILES (unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES (sys/ioctl.h HAVE_SYS_IOCTL_H)
CHECK_INCLUDE_FILES (execinfo.h HAVE_EXEINFO_H)


CHECK_INCLUDE_FILE_CXX (cxxabi.h HAVE_CXXABI_H)


# find additional packages
#
# With MSVC using pre-installed dynamic libraries is usually a pain because of
# the incompatibilities in the compiler flags
#
IF (MSVC)
  SET(SEARCH_LIBS_DEFAULT FALSE)
ELSE(MSVC)
  SET(SEARCH_LIBS_DEFAULT TRUE)
ENDIF (MSVC)




# Taken from ITK:
# On Visual Studio 8 MS deprecated C. This removes all 1.276E1265 security
# warnings
IF(MSVC)
  ADD_DEFINITIONS(
    -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
    -D_CRT_IS_WCTYPE_NO_DEPRECATE
    -D_CRT_MANAGED_FP_NO_DEPRECATE
    -D_CRT_NONSTDC_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
    -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
    -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
    -D_CRT_VCCLRIT_NO_DEPRECATE
    -D_SCL_SECURE_NO_DEPRECATE
    -D_SECURE_SCL=0
    )
ENDIF(MSVC)

SET(SOURCE_ROOT "${CMAKE_CURRENT_SOURCE_DIR}")
SET(BUILD_ROOT "${CMAKE_CURRENT_BINARY_DIR}")
SET(LIB_ROOT_INSTALL_PATH "${CMAKE_INSTALL_FULL_LIBDIR}/${MIA_NAME}")
SET(CONFIG_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/config")
SET(LIB_INCLUDE_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/include")
SET(PLUGIN_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/plugins")
SET(PLUGIN_SEARCH_PATH "${PLUGIN_INSTALL_PATH}")
SET(DOC_INSTALL_PATH "share/doc/${MIA_NAME}")
SET(FULL_DOC_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${DOC_INSTALL_PATH}")
SET(BINARY_INSTALL_PATH "${CMAKE_INSTALL_BINDIR}")
SET(LIBRARY_INSTALL_PATH "${CMAKE_INSTALL_LIBDIR}")
SET(INCLUDE_INSTALL_PATH "${CMAKE_INSTALL_INCLUDEDIR}/${MIA_NAME}")
SET(MIA_DOCTOOLS_INSTALL_ROOT "${CMAKE_INSTALL_PREFIX}/share/mia-doctools")

######################################################################################
#
# Handle BOOST
#
#
MACRO(GET_BOOST_LINKERFLAG VAR LIBNAMES)
  FOREACH(L  ${LIBNAMES})
    STRING(REGEX MATCH "boost_[-_a-z0-9]*" temp ${L})
    STRING(LENGTH "${temp}" TEMP_LENGTH)
    IF(${TEMP_LENGTH})
      SET(flags "${flags} -l${temp}")
    ENDIF(${TEMP_LENGTH})
  ENDFOREACH(L  ${LIBNAMES})
  
  SET(${VAR} "${flags}")
ENDMACRO(GET_BOOST_LINKERFLAG)

SET(BOOST_COMPONENTS filesystem  unit_test_framework serialization system)

IF (MIA_USE_BOOST_REGEX)
  SET(BOOST_COMPONENTS  ${BOOST_COMPONENTS} regex)
ENDIF()

IF (WIN32)
  SET(BOOST_COMPONENTS  ${BOOST_COMPONENTS} date_time)
ENDIF(WIN32)

FIND_PACKAGE( Boost 1.50.0 COMPONENTS
  ${BOOST_COMPONENTS}
  REQUIRED)

INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})

ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
ADD_DEFINITIONS(-DBOOST_FILESYSTEM_VERSION=3)

IF (MIA_USE_BOOST_REGEX)
  SET(BOOST_DEPS ${Boost_REGEX_LIBRARY}  ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
ELSE()
  SET(BOOST_DEPS ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
ENDIF()

SET(BOOST_UNITTEST  ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})

IF (WIN32 AND NOT UNIX)
   FOREACH(l 
       ${Boost_REGEX_LIBRARIES}
       ${Boost_FILESYSTEM_LIBRARY}
       ${Boost_SYSTEM}
       ${Boost_DATE_TIME}
       )
      STRING(REGEX MATCH "lib$" head ${l})
      STRING(COMPARE EQUAL "xlib" "x${head}" islib)
      IF (${islib})
	  STRING(REGEX REPLACE "lib$" "dll" lDLL ${l})
	  INSTALL(FILES ${lDLL} DESTINATION "bin")
      ENDIF(${islib})
   ENDFOREACH(l)
ENDIF (WIN32 AND NOT UNIX)

IF (MSYS OR MINGW)
  SET(BASELIBS ${BOOST_DEPS})
ENDIF (MSYS OR MINGW)

#
# end BOOST 
#
################################################################################

################################################################################
#
# Intel Threading Building Blocks 
#
OPTION(WITH_TBB "Use intel threading building blocks for threading, otherwise use c++11 threads" OFF)

IF(WITH_TBB) 
  FIND_PACKAGE(TBB REQUIRED)
  IF(TBB_FOUND) 
    include_directories(${TBB_INCLUDE_DIRS})
    link_directories(${TBB_LIBRARY_DIRS})
    SET(HAVE_TBB 1)
  ELSE(TBB_FOUND) 
    MESSAGE(FATAL " TBB not found")
  ENDIF(TBB_FOUND)
ENDIF()
#
# End Intel Threading Building Blocks 
#
################################################################################

################################################################################
#
# Intel Threading Building Blocks 
# why is this here? 

SET(CMAKE_THREAD_PREFER_PTHREAD ON) 
FIND_PACKAGE(Threads)

IF(CMAKE_USE_PTHREADS_INIT)
  set(PTHREADLIB -lpthread)
ENDIF(CMAKE_USE_PTHREADS_INIT)

################################################################################
# 
# Handle the GNU Scientific Library, this might be a showstopper 
# on MS windows when using Visual C++ 
#
PKG_CHECK_MODULES(GSL REQUIRED gsl)
INCLUDE_DIRECTORIES(${GSL_INCLUDE_DIRS})
LINK_DIRECTORIES(${GSL_LIBRARY_DIRS})


PKG_CHECK_MODULES(EIGEN3 REQUIRED eigen3)
INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIRS})
LINK_DIRECTORIES(${EIGEN3_LIBRARY_DIRS})


IF(UNIX)
  GET_BOOST_LINKERFLAG(BOOST_LIBFLAG "${BOOST_DEPS}")
  SET(MIA_DEPEND_LIBRARIES "${BOOST_LIBFLAG} ${TBB_LIBRARIES} ${PTHREADLIB} -ldl")
ENDIF(UNIX)

##################################################################################
#
# Find gzip for man page compression 
#
find_program(GZIP gzip)
IF(NOT GZIP) 
  MESSAGE(gzip not found, man pages will not be compressed)
ENDIF(NOT GZIP) 

##################################################################################
#
# take care of modules loading infrastructure
#
IF(NOT WIN32)

  FIND_LIBRARY(DL dl
    PATH
    /lib
    /usr/lib
    /opt/local/lib
    /sw/lib
  )
  IF(DL_NOTFOUND)

=== addons/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

INCLUDE_DIRECTORIES("${CMAKE_CURRENT_SOURCE_DIR}")

ADD_SUBDIRECTORY( dicom )
ADD_SUBDIRECTORY( itpp )
ADD_SUBDIRECTORY( jpg )
ADD_SUBDIRECTORY( hdf5 )
ADD_SUBDIRECTORY( openexr )
ADD_SUBDIRECTORY( maxflow )
ADD_SUBDIRECTORY( nifti )
ADD_SUBDIRECTORY( nlopt )
ADD_SUBDIRECTORY( png )
ADD_SUBDIRECTORY( tiff )
ADD_SUBDIRECTORY( vtk   )
ADD_SUBDIRECTORY( vistaio )

=== cmake/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

=== doc/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#


INCLUDE (${CMAKE_ROOT}/Modules/FindDoxygen.cmake)


ADD_CUSTOM_TARGET(docs echo "creating documentation")
add_dependencies(doc docs)  

SET(MIADOCTOOLS_FILES 
  miareadxml.py  
  miawritprogram.py  
  MiaDoctools.cmake
  __init__.py
  )

SET(MIADOCTOOLS_PYTHON_EXE
  miaxml2man.py  
  miaxml2nipype.py  
  miaxml2sgml.py
  )


IF(MIA_CREATE_USERDOC) 

  INSTALL(FILES ${MIADOCTOOLS_FILES} DESTINATION ${MIA_DOCTOOLS_INSTALL_ROOT})
  
  INSTALL(PROGRAMS ${MIADOCTOOLS_PYTHON_EXE} DESTINATION ${MIA_DOCTOOLS_INSTALL_ROOT})

  ##################################################################
  #  for html userref xsltproc and the style sheet is needed
  #
  find_program(XSLTPROC xsltproc)
  IF(XSLTPROC)
    FIND_PATH(HTML_CHUNK_FILEPATH chunk.xsl
      PATHS 
      /usr/share/sgml/docbook/xsl-stylesheets/html/
      /usr/share/xml/docbook/stylesheet/docbook-xsl/html/
      DOC "style sheet for the creation of the user reference"
      )
  ELSE (XSLTPROC)
    IF(STRICT_DEPENDECIES)
      MESSAGE(ERROR ": xsltproc not found and STRICT_DEPENDECIES set")
    ENDIF(STRICT_DEPENDECIES)
  ENDIF(XSLTPROC)
  
  IF(HTML_CHUNK_FILEPATH) 
    #
    # handle the linking of some files to run the 
    # 
    ADD_CUSTOM_TARGET(userref_outdir mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/userref)
    ADD_CUSTOM_TARGET(userref_css 
      cp  ${CMAKE_CURRENT_SOURCE_DIR}/progref.css 
      ${CMAKE_CURRENT_BINARY_DIR}/userref/progref.css DEPENDS userref_outdir)

    ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/progref.xml
      COMMAND ln ARGS -sf ${CMAKE_CURRENT_SOURCE_DIR}/progref.xml ${CMAKE_CURRENT_BINARY_DIR}/progref.xml) 

    ADD_CUSTOM_TARGET(progref_link DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/progref.xml)

    MESSAGE("Python=${Python3_EXECUTABLE}")
    ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/program.xml 
      COMMAND ${Python3_EXECUTABLE} ARGS ${CMAKE_CURRENT_SOURCE_DIR}/miaxml2sgml.py ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}
      DEPENDS xmldoc
      )
    
    ADD_CUSTOM_TARGET(process_xml DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/program.xml)

      
    ADD_CUSTOM_COMMAND(OUTPUT  "userref.stamp"
      COMMAND  
      ${XSLTPROC} ARGS 
      --param chunk.section.depth 3 
      --param chunk.first.sections 1 
      --param use.id.as.filename 1 
      --stringparam html.stylesheet  progref.css 
      --output "userref/" 
      ${HTML_CHUNK_FILEPATH}/chunk.xsl progref.xml
      COMMAND touch ARGS userref.stamp
      DEPENDS process_xml userref_css userref_outdir progref_link ${CMAKE_CURRENT_BINARY_DIR}/program.xml ) 
    
    ADD_CUSTOM_TARGET(userref DEPENDS userref.stamp)
    add_dependencies(docs userref)
    
    ####################################################
    #
    # installation of the user reference 
    IF(ALWAYS_CREATE_DOC)
      INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/userref DESTINATION ${DOC_INSTALL_PATH}/)
      CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/mia2-doc.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/mia2-doc.desktop)
      INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/mia2-doc.desktop DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
    ENDIF(ALWAYS_CREATE_DOC)     
  ENDIF(HTML_CHUNK_FILEPATH) 
  
ENDIF(MIA_CREATE_USERDOC)

OPTION(DOXYGEN_USE_MATHJAX "Use mathjax for formulas in html documentation" ON)

IF (DOXYGEN_FOUND)
  ADD_CUSTOM_TARGET(LibraryDoc echo "creating user library documentation")
  ADD_DEPENDENCIES(docs LibraryDoc)
  
  IF(DOXYGEN_DOT_FOUND)
    SET(HAVE_DOT YES)
  ENDIF(DOXYGEN_DOT_FOUND)

  IF(DOXYGEN_USE_MATHJAX)
    SET(USE_MATHJAX YES)
    FIND_PATH(MATHJAX_CODEFILE MathJax.js
      PATHS
      /usr/share/mathjax/
      /usr/share/javascript/
      /usr/share/javascript/mathjax/
      )
    IF(NOT MATHJAX_CODEFILE)
      MESSAGE(STATUS "No mathjax installation found, Doxygen will create the documentation linking to the on-line version") 
    ENDIF()
  ENDIF()
  
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/reference.dox.cmake 
    ${CMAKE_CURRENT_BINARY_DIR}/reference.dox)
  
  ADD_CUSTOM_COMMAND(SOURCE COMMAND ${DOXYGEN_EXECUTABLE}
    ARGS  "${CMAKE_CURRENT_BINARY_DIR}/reference.dox"
    TARGET LibraryDoc
    OUTPUTS libdoc)
  
  IF(ALWAYS_CREATE_DOC) 
    INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/libdoc/html/ DESTINATION ${DOC_INSTALL_PATH}/libdoc/)
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/libmia2-doc.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/libmia2-doc.desktop)
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libmia2-doc.desktop DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
  ENDIF(ALWAYS_CREATE_DOC)     
 
ENDIF (DOXYGEN_FOUND)

=== src/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#
#

ADD_CUSTOM_TARGET(xmldoc)

INCLUDE (${CMAKE_SOURCE_DIR}/doc/MiaDoctools.cmake)

SET(NIPYPE_INTERFACE_INIT_FILE ${CMAKE_CURRENT_BINARY_DIR}/__init__.py)
MIA_PREPARE_AUTODOC(mia)

ADD_CUSTOM_TARGET(mandir COMMAND mkdir -p ${CMAKE_BINARY_DIR}/doc/man)

LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/../mia/core)
LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/../mia/2d)
LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/../mia/3d)

#basic helpers 
DEFEXE(filenumberpattern  miacore  )
DEFEXE(cmeans             miacore  )
DEFEXE(labelsort          miacore  )
DEFEXE(wavelettrans       miacore  )
DEFEXE(myowavelettest     miacore  )

#2D programs 
DEFEXE(2dimagefilter      mia2d )
DEFEXE(2dcost             mia2d )
DEFEXE(2ddistance         mia2d )
DEFEXE(multihist          mia2d )
DEFEXE(2dimagestats       mia2d )
DEFEXE(2dimagefilterstack mia2d )
DEFEXE(2dimagecreator     mia2d )
DEFEXE(2dimagecombiner    mia2d )
DEFEXE(raw2image          mia2d )
DEFEXE(2ddeform           mia2d )
DEFEXE(2dtransform        mia2d )
DEFEXE(2dforce            mia2d )
DEFEXE(2davgmasked        mia2d )
DEFEXE(2dimageregistration mia2d )
DEFEXE(2dimageselect      mia2d )
DEFEXE(2dimagecombine-dice mia2d )
DEFEXE(2dfuzzysegment     mia2d )
DEFEXE(2dsegment-ahmed    mia2d )
DEFEXE(2dsegment-fuzzyw   mia2d )
DEFEXE(2dsegment-local-cmeans    mia2d )
DEFEXE(2dsegment-local-kmeans    mia2d )
DEFEXE(2dsegment-per-pixel-kmeans mia2d )
DEFEXE(2dmultiimagevar    mia2d )
DEFEXE(2dmultiimageregistration    mia2d )
DEFEXE(2dmulti-force      mia2d )
DEFEXE(2dimagefullstats   mia2d )
DEFEXE(2dbinarycombine    mia2d )
DEFEXE(2dtransformation-to-strain mia2d)
DEFEXE(2dimageseries-maximum-intensity-projection mia2d) 
DEFEXE(2dfluid-syn-registration mia2d)

DEFCHKEXE(2dlerp mia2d )


#Programs related to 2D myocardic perfusion 

DEFEXE(2dsegshift             mia2dmyocardperf )
DEFEXE(2dsegshiftperslice     mia2dmyocardperf )
DEFEXE(2dsegseriesstats       mia2dmyocardperf )
DEFEXE(2dseries2dordermedian  mia2dmyocardperf )
DEFEXE(2dmyoserial-nonrigid   mia2dmyocardperf )
DEFEXE(2dmyoperiodic-nonrigid mia2dmyocardperf )
DEFEXE(2dseriescorr           mia2dmyocardperf )
DEFEXE(2dseriesgradvariation  mia2dmyocardperf )
DEFEXE(2dseriesgradMAD        mia2dmyocardperf )
DEFEXE(2dseriessmoothgradMAD  mia2dmyocardperf )
DEFEXE(2dsegmentcropbox       mia2dmyocardperf )
DEFEXE(2dseghausdorff         mia2dmyocardperf )
DEFEXE(2dserieshausdorff      mia2dmyocardperf )
DEFEXE(2dsegcompare           mia2dmyocardperf )
DEFEXE(2dgroundtruthreg       mia2dmyocardperf )
DEFEXE(2dseries2sets          mia2dmyocardperf )
DEFEXE(2dseries-segdistance   mia2dmyocardperf )
DEFEXE(2dseries-mincorr       mia2dmyocardperf )

DEFEXE(2dseries-sectionmask   mia2dmyocardperf )
DEFEXE(2dmyoseries-dice       mia2dmyocardperf )
DEFEXE(2dmyoseries-compdice   mia2dmyocardperf )
DEFEXE(2dmyopgt-nonrigid      mia2dmyocardperf )
DEFEXE(2dmany2one-nonrigid    mia2dmyocardperf )
DEFEXE(2dmyoset-all2one-nonrigid    mia2dmyocardperf )


DEFEXE(2dmyocard-segment      mia2dmyocardperf )
DEFEXE(2dmyoica-full          mia2dmyocardperf )
DEFEXE(2dmyoicapgt            mia2dmyocardperf )
DEFEXE(2dmyomilles            mia2dmyocardperf )
DEFEXE(2dmyocard-ica          mia2dmyocardperf )
DEFEXE(2dmyocard-icaseries    mia2dmyocardperf )
DEFEXE(2dmyoica-nonrigid      mia2dmyocardperf )
DEFEXE(2dmyoica-nonrigid-parallel      mia2dmyocardperf )
DEFEXE(2dmyoica-nonrigid2     mia2dmyocardperf )
SET(PERF_AND_3D_LIBS mia3d mia2dmyocardperf) 
DEFEXE(2dseriestovolume  "${PERF_AND_3D_LIBS}")

DEFEXE(2dgrayimage-combine-to-rgb mia2d)
DEFEXE(2deval-transformquantity mia2d)
DEFEXE(2dtrackpixelmovement mia2d )

DEFCHKEXE(3dlerp mia3d )

DEFEXE(2dstack-cmeans-presegment  mia3d )

DEFEXE(2dmultiimageto3d   mia3d )
DEFEXE(3dimagestats       mia3d )
DEFEXE(3dcost             mia3d )
DEFEXE(3ddistance         mia3d )
DEFEXE(3dimagefilter      mia3d )
DEFEXE(3dimagecombine     mia3d )
DEFEXE(3dimagecreator     mia3d )
DEFEXE(3dimagefilterstack mia3d )
DEFEXE(2dimagestack-cmeans mia3d )
DEFEXE(raw2volume         mia3d )
DEFEXE(3dcrispsegment     mia3d )
DEFEXE(3ddeform           mia3d )
DEFEXE(3dforce            mia3d )
DEFEXE(3dfuzzysegment     mia3d )
DEFEXE(3dgetslice         mia3d )
DEFEXE(3dgetsize          mia3d )
DEFEXE(2dto3dimage        mia3d )
DEFEXE(2dto3dimageb       mia3d )
DEFEXE(3drigidreg         mia3d )
DEFEXE(3dnonrigidreg      mia3d )
DEFEXE(3dnonrigidreg-alt  mia3d )
DEFEXE(2dstackfilter      mia3d )
DEFEXE(3dtransform        mia3d )
DEFEXE(3dmaskseeded       mia3d )
DEFEXE(3dfield2norm       mia3d )
DEFEXE(3dimageselect      mia3d )
DEFEXE(3dbrainextractT1   mia3d )
DEFEXE(3dbinarycombine    mia3d )
DEFEXE(3ddistance-stats   mia3d )
DEFEXE(3dimageaddattributes  mia3d )
DEFEXE(3dvectorfieldcreate  mia3d )
DEFEXE(3dserial-nonrigid  mia3d )
DEFEXE(3dmany2one-nonrigid  mia3d )
DEFEXE(3dprealign-nonrigid mia3d )
DEFEXE(3dseries-track-intensity mia3d )
DEFEXE(3dtransform2vf mia3d )
DEFEXE(3dtrackpixelmovement mia3d )
DEFEXE(3dvf2transform mia3d )
DEFEXE(3dvfcompare mia3d )
DEFEXE(3deval-transformquantity mia3d)
DEFEXE(3dcost-translatedgrad mia3d)
DEFEXE(3dsegment-ahmed    mia3d)
DEFEXE(3dsegment-local-cmeans    mia3d )
DEFEXE(3dcombine-mr-segmentations mia3d)
DEFEXE(3dcombine-imageseries mia3d)
DEFEXE(3dpropose-boundingbox mia3d)
DEFEXE(3dimagestatistics-in-mask mia3d)
DEFEXE(3dfluid-syn-registration mia3d)

DEFEXE(3dlandmarks-transform mia3d)
DEFEXE(3dlandmarks-distances mia3d)

DEFEXE(plugin-help miamesh )
DEFEXE(meshdistance-to-stackmask miamesh )
DEFEXE(meshfilter miamesh )
DEFEXE(mesh-deformable-model miamesh )
DEFEXE(mesh-to-maskimage  miamesh)

ADD_EXECUTABLE(mia-test-plugins-as-installed test_plugins_as_installed.cc)  
TARGET_LINK_LIBRARIES(mia-test-plugins-as-installed miamesh)
TARGET_LINK_LIBRARIES(mia-test-plugins-as-installed ${BOOST_UNITTEST})
IF(WIN32)
  SET_TARGET_PROPERTIES(test-3d-${name} PROPERTIES LINKER_FLAGS "/NODEFAULTLIB:MSVCRT")
ENDIF(WIN32)


IF(ITPP_FOUND) 
  DEFEXE(3dmotioncompica-nonrigid mia3d )
ENDIF(ITPP_FOUND) 

ADD_SUBDIRECTORY(fluid2d  )
ADD_SUBDIRECTORY(fluid3d  )
ADD_SUBDIRECTORY(isosurface  )

=== testdata/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#
#

=== addons/dicom/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

OPTION(WITH_DCMTK "enable support for DCMTK DICOM IO" ${SEARCH_LIBS_DEFAULT})


SET(dicom4mia_SOURCES dicom4mia.cc)

SET(image2dio_path ${PLUGIN_INSTALL_PATH}/2dimage/io)
SET(image3dio_path ${PLUGIN_INSTALL_PATH}/3dimage/io)

IF (WITH_DCMTK)
  FIND_PACKAGE(DCMTKnew)
  IF(DCMTK_FOUND)
    DEFINE_PROPERTY(GLOBAL PROPERTY HAVE_DCMTK_PROP BRIEF_DOCS "yeah" FULL_DOCS "yeah")
    SET(dicom4mia_deps mia3d ${DCMTK_LIBRARIES})

   
    MIA_ADD_LIBRARY(dicom4mia "${dicom4mia_SOURCES}" "${dicom4mia_deps}")
    INSTALL_BASE(dicom4mia)

    SET(DCMTK_LINK_LIBS_2D dicom4mia)
    SET(DCMTK_LINK_LIBS_3D dicom4mia)
    NEW_TEST(dicom4mia dicom4mia)

    PLUGIN_WITH_TEST_AND_PREFIX2("2dimage" "io" dcm2d "${DCMTK_LINK_LIBS_2D}")
    PLUGIN_WITH_TEST_AND_PREFIX2("3dimage" "io" dcm3d "${DCMTK_LINK_LIBS_3D}")
    INCLUDE_DIRECTORIES(${DCMTK_INCLUDE_DIR})

  ELSEIF(STRICT_DEPENDECIES)
    MESSAGE(FATAL_ERROR "DCMTK not found and strict dependencies enabled")
  ENDIF(DCMTK_FOUND)
ENDIF(WITH_DCMTK)

=== addons/hdf5/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

OPTION(WITH_HDF5 "use hdf5 for data UI" TRUE)


IF (WITH_HDF5)
  if (STRICT_DEPENDECIES)
    find_package(HDF5 REQUIRED)
  else (STRICT_DEPENDECIES)
    find_package(HDF5)
  endif (STRICT_DEPENDECIES)
  
  IF(HDF5_FOUND)
    DEFINE_PROPERTY(GLOBAL PROPERTY HAVE_HDF5_PROP BRIEF_DOCS "yeah" FULL_DOCS "yeah")
    INCLUDE_DIRECTORIES(${HDF5_INCLUDE_DIRS})
    LINK_DIRECTORIES(${HDF5_LIBRARY_DIRS})
    SET(HDF5IO_SRC hdf5mia.cc hdf5a_mia.cc)
    SET(HDF5MIALIBS mia3d ${HDF5_LIBRARIES})
    MIA_ADD_LIBRARY(miahdf5 "${HDF5IO_SRC}" "${HDF5MIALIBS}")
    SET(INSTALL_TARGETS miahdf5)	
    INSTALL_BASE("${INSTALL_TARGETS}")


    NEW_TEST(hdf5mia miahdf5)

    PLUGIN_WITH_TEST_AND_PREFIX2("3dimage" "io" hdf5_3dimage  miahdf5)

  ENDIF(HDF5_FOUND)
  
ENDIF(WITH_HDF5)

=== addons/itpp/CMakeLists.txt ===
###################################################################################
#
# Look for IT++ for FastICA
#
OPTION(WITH_ITPP "Use IT++ for alternative FastICA implementation" ${SEARCH_LIBS_DEFAULT})
IF(WITH_ITPP)
  
  IF (STRICT_DEPENDECIES)
    pkg_check_modules(ITPP itpp REQUIRED)
  ELSE (STRICT_DEPENDECIES)
    pkg_check_modules(ITPP itpp)
  ENDIF(STRICT_DEPENDECIES)
  
  IF(ITPP_FOUND)
    INCLUDE_DIRECTORIES(${ITPP_INCLUDE_DIRS})
    LINK_DIRECTORIES(${ITPP_LIBRARY_DIRS})
    #if ITPP was found check if it supports the return value in separate
    SET(CMAKE_REQUIRED_LIBRARIES ${ITPP_LIBRARIES})
    CHECK_CXX_SOURCE_COMPILES(
"#include <itpp/signal/fastica.h>

int main(int argc, char *args[]) 
{
	itpp::mat  m_Signal(1,1);
	itpp::Fast_ICA ica(m_Signal); 
	if (ica.separate())
	  return 0; 
	else
	  return -1;
}
" ITPP_FASTICA_SEPARATE_HAS_RETURNVALUE)

    IF(NOT ITPP_FASTICA_SEPARATE_HAS_RETURNVALUE) 
      MESSAGE(WARNING "You are using  an unpatched version of IT++. "
	"In this version using APPROACH_DEFL may run forever, and FastICA::separate " 
	"doesn't return a value indicating success, "
	"therefore, APPROACH_DEFL will not be used. See also: "
	"https://sourceforge.net/tracker/?func=detail&aid=3028968&group_id=37044&atid=418758")
      SET(ICA_ALWAYS_USE_SYMM 1)
    ELSE(NOT ITPP_FASTICA_SEPARATE_HAS_RETURNVALUE) 
      SET(ICA_ALWAYS_USE_SYMM 0)
    ENDIF(NOT ITPP_FASTICA_SEPARATE_HAS_RETURNVALUE)

    SET( FAST_ICA_LIBRARIES ${ITPP_LIBRARIES} miacore)
    PLUGINGROUP_WITH_TEST_AND_PREFIX2("fastica" "implementation" "ica" "${FAST_ICA_LIBRARIES}")
    
  ENDIF(ITPP_FOUND)
ENDIF(WITH_ITPP)
#
# End looking for IT++ 
#
##################################################################################

=== addons/jpg/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

OPTION(WITH_JPEG "enable support for JPEG gray scale images IO and RGB saving" ${SEARCH_LIBS_DEFAULT})

IF(WITH_JPEG)
  IF(STRICT_DEPENDECIES)
    FIND_PACKAGE(JPEG REQUIRED)
  ELSE(STRICT_DEPENDECIES)
    FIND_PACKAGE(JPEG)
  ENDIF(STRICT_DEPENDECIES)
ENDIF(WITH_JPEG)

IF(JPEG_FOUND)
  DEFINE_PROPERTY(GLOBAL PROPERTY HAVE_JPG_PROP BRIEF_DOCS "yeah" FULL_DOCS "yeah")
  SET(JPEG_LINK_LIBS mia2d ${JPEG_LIBRARIES})
  INCLUDE_DIRECTORIES(${JPEG_INCLUDE_DIR})

  PLUGIN_WITH_PREFIX2("2dimage" "io" jpg-gray "${JPEG_LINK_LIBS}")
  PLUGIN_WITH_PREFIX2("rgbimage" "io" jpg-rgb "${JPEG_LINK_LIBS}" "${rgbimage2dio_path}")

  NEW_TEST(jpg mia2d)
ENDIF(JPEG_FOUND)

=== addons/maxflow/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

OPTION(WITH_MAXFLOW "enable support for maxflow-mincut based filters" ${SEARCH_LIBS_DEFAULT})
IF(WITH_MAXFLOW)
  IF(NOT MAXFLOW_LIBRARIES) 
    PKG_CHECK_MODULES(MAXFLOW maxflow)
  ENDIF(NOT MAXFLOW_LIBRARIES) 

  IF(MAXFLOW_LIBRARIES)
    INCLUDE_DIRECTORIES(${MAXFLOW_INCLUDE_DIRS})

    DEFINE_PROPERTY(GLOBAL PROPERTY HAVE_MAXFLOW_PROP BRIEF_DOCS "yeah" FULL_DOCS "yeah")
    SET(MAXFLOWLIBS mia2d ${MAXFLOW_LIBRARIES})
    LINK_DIRECTORIES(${MAXFLOW_LIBRARY_DIRS})

    PLUGIN_WITH_TEST_AND_PREFIX2("2dimage" "filter" 2dmaxflow "${MAXFLOWLIBS}")
  ELSE (MAXFLOW_LIBRARIES)
    IF(STRICT_DEPENDECIES)
      MESSAGE(ERROR "Requested library maxflow not found and STRICT_DEPENDECIES given")
    ENDIF(STRICT_DEPENDECIES)
  ENDIF(MAXFLOW_LIBRARIES)
ENDIF(WITH_MAXFLOW)

=== addons/nifti/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

OPTION(WITH_NIFTI "Use nifti-1 3D image file format" TRUE)

IF (WITH_NIFTI)
  SET(NIFTI_FOUND FALSE)
  
  # zlib is required for nifti to function 
  FIND_PACKAGE(ZLIB)
  IF(ZLIB_FOUND) 
    # check that nifti header is available 
    FIND_PATH( NIFTI_INCLUDE_DIR nifti1_io.h
      /usr/include 
      /usr/include/nifti
      /usr/local/include
      /usr/local/include/nifti 
      )
    
    FIND_LIBRARY(NIFTIIO_LIBRARY
      NAMES
      niftiio 
      ) 

    FIND_LIBRARY(NIFTIZNZ_LIBRARY
      NAMES
      znz 
      ) 
    IF( NIFTIIO_LIBRARY AND NIFTIZNZ_LIBRARY AND NIFTI_INCLUDE_DIR) 
      SET(NIFTI_FOUND TRUE)
      SET(NIFTIIO_LIBRARIES 
        ${NIFTIIO_LIBRARY}
        ${NIFTIZNZ_LIBRARY}
        ${ZLIB_LIBRARIES}
        m)
      MESSAGE(STATUS "libz=${ZLIB_LIBRARIES}")
    ENDIF()
    
  ENDIF(ZLIB_FOUND) 

  if (NOT NIFTI_FOUND AND STRICT_DEPENDECIES)
    MESSAGE(FATAL_ERROR "NIFTI includes and or libraries not found and strict dependencies enabled")
  endif (NOT NIFTI_FOUND AND STRICT_DEPENDECIES)

  IF (NIFTI_FOUND) 
    INCLUDE_DIRECTORIES(${NIFTI_INCLUDE_DIR})
    INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
    
    SET(imageio_path "${PLUGIN_INSTALL_PATH}/3dimage/io")
    SET(NIFTI_LINK_LIBS_3D ${NIFTIIO_LIBRARIES} mia3d)
    PLUGIN_WITH_TEST_AND_PREFIX2("3dimage" "io" niftiimage "${NIFTI_LINK_LIBS_3D}")
  ENDIF()
  
ENDIF (WITH_NIFTI)

=== debian/changelog ===
mia (2.4.7-16) unstable; urgency=medium

  * Team upload.
  * debian/rules: Move the cmdxmlhelp test from SKIP_32 to the common SKIP
    variable; it fails on s390x.
  * debian/tests/testsuite: Likewise.

 -- Yavor Doganov <yavor@gnu.org>  Sat, 25 Oct 2025 02:01:09 +0300

mia (2.4.7-15) unstable; urgency=medium

  * Team upload.
  * debian/rules: Skip more failing tests.
  * debian/tests/testsuite: Likewise.

 -- Yavor Doganov <yavor@gnu.org>  Fri, 24 Oct 2025 04:14:46 +0300

mia (2.4.7-14) unstable; urgency=medium

  [ ikeadeoyin ]
  * Team upload.
  * Add autopkgtest

  [ Yavor Doganov ]
  * debian/patches/gcc-14.patch: New; fix FTBFS with GCC 14 and 15
    (Closes: #1075270).
  * debian/patches/groff-warnings.patch: New.
  * debian/patches/spelling-errors.patch: Likewise.
  * debian/patches/vtk9.patch: Fix DEP-3 headers.
  * debian/patches/fix-g++11.diff: Likewise.
  * debian/patches/fix-gcc-13.patch: Likewise.
  * debian/rules: Remove workarounds for mips and mipsel.
    (override_dh_auto_configure): Pass -DCMAKE_POLICY_VERSION_MINIMUM=3.5
    to fix FTBFS with CMake 4 (Closes: #1113285).
    (override_dh_auto_test-arch): New; always skip a flaky test and two
    additional tests on 32-bit architectures.
    (override_dh_auto_test-indep): New dummy target.
  * debian/control (Build-Depends): Require libvtk9-dev (>= 9.5) for the
    ongoing vtk9 library transition.
    (Rules-Requires-Root): Remove; it's the default.
    (Standards-Version): Claim compliance with 4.7.2; no changes needed.
    (libmia-2.4-4): Mark as Multi-Arch: same.
  * debian/tests/testsuite: New test; run the whole testsuite.  This is
    likely to timeout on some architectures.
  * debian/tests/control (Tests): Set to testsuite.
    (Depends): Set to @builddeps@ only.
    (Restrictions): Add build-needed.
  * debian/tests/run-unit-test: Delete; these tests are part of the
    testsuite and cannot be run in isolation without a built tree.
  * debian/README.test: Delete.
  * debian/docs: Likewise.
  * debian/libmia-2.4-doc.install: Remove config.h.
  * debian/libmia-2.4-doc.examples: Replace test/testdata with
    examples/2d/filter/*.  The latter is equally useless as examples but
    at least silence a Lintian complaint in pedantic mode.
  * debian/libmia-2.4-doc.lintian-overrides: Delete; unused.
  * debian/libmia-2.4-4.lintian-overrides: Fix typo in the comment.
  * debian/mia-tools.lintian-overrides: Remove
    python-package-missing-depends-on-python; unused.
  * debian/watch: Upgrade to version 5.
  * debian/copyright: Update copyright years for Debian packaging.

  [ Andreas Tille ]
  * d/copyright: Secure URI in Source field
  * Use default Salsa CI

 -- Yavor Doganov <yavor@gnu.org>  Wed, 22 Oct 2025 11:46:43 +0300

mia (2.4.7-13) unstable; urgency=medium

  * Team upload.

  [ Zixing Liu ]
  * fix an issue where gsl_iterator.hh is not installed

  [ Andreas Tille ]
  * Standards-Version: 4.6.2 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Use secure URI in Homepage field.

 -- Andreas Tille <tille@debian.org>  Tue, 29 Aug 2023 11:00:00 +0200

mia (2.4.7-12) unstable; urgency=medium

  * Team upload.
  * fix gcc-13 build issue. (Closes: #1037775)

 -- Bo YU <tsu.yubo@gmail.com>  Sat, 29 Jul 2023 22:49:01 +0800

mia (2.4.7-11) unstable; urgency=medium

  * Team upload
  * d/patches: Refresh patch to handle openexr 3.x. Closes: #1017517

 -- Mathieu Malaterre <malat@debian.org>  Wed, 17 Aug 2022 15:27:13 +0200

mia (2.4.7-10) unstable; urgency=medium

  * Team upload

  [ Andreas Tille ]
  * Build against vtk9
    Closes: #1013159

  [ Francois Mazen ]
  * Patch to build against vtk9
    Closes: #1012689

 -- Andreas Tille <tille@debian.org>  Sat, 18 Jun 2022 10:28:32 +0200

mia (2.4.7-9) unstable; urgency=medium

  * Team upload.
  * Rebuild against dcmtk 3.6.7
  * Standards-Version: 4.6.1 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Update renamed lintian tag names in lintian overrides.

 -- Andreas Tille <tille@debian.org>  Thu, 12 May 2022 09:46:11 +0200

mia (2.4.7-8) unstable; urgency=medium

  *  Fix compilation with latest BOOST

 -- Gert Wollny <gewo@debian.org>  Sun, 21 Nov 2021 14:56:19 +0100

mia (2.4.7-8~exp1) experimental; urgency=medium

  * Fix compilation with g++11, Closes: #984233

 -- Gert Wollny <gewo@debian.org>  Sun, 21 Mar 2021 09:41:04 +0100

mia (2.4.7-7) unstable; urgency=medium

  * d/p/: Add patch to fix location of boost headers

 -- Gert Wollny <gewo@debian.org>  Mon, 11 Jan 2021 22:49:29 +0100

mia (2.4.7-6) unstable; urgency=medium

  [ Andreas Tille ]
  * Team upload.
  * Set -DCMAKE_SKIP_INSTALL_ALL_DEPENDENCY=OFF (which was changed due to
    debhelper compat level 13 in 2.4.7-3)
    Closes: #976756

 -- Gert Wollny <gewo@debian.org>  Mon, 11 Jan 2021 22:48:25 +0100

mia (2.4.7-5) unstable; urgency=medium

  * Team upload.
  * Ignore failures when trying to install some files that are not built
    in arch all builds
    Closes: #976756

 -- Andreas Tille <tille@debian.org>  Fri, 01 Jan 2021 18:22:49 +0100

mia (2.4.7-4) unstable; urgency=medium

  * Team upload.
  * Fix maintainer address
    Closes: #976830

 -- Andreas Tille <tille@debian.org>  Mon, 14 Dec 2020 21:15:21 +0100

mia (2.4.7-3) unstable; urgency=medium

  * Team upload.
  * Build-Depends: s/libnifti-dev/libnifti2-dev/
  * Remove redundant debian/gbp.conf
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Enable dh_missing --fail-missing

 -- Andreas Tille <tille@debian.org>  Mon, 07 Dec 2020 15:25:46 +0100

mia (2.4.7-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set field Upstream-Contact in debian/copyright.
  * Set upstream metadata fields: Repository.
  * Remove obsolete field Contact from debian/upstream/metadata (already
    present in machine-readable debian/copyright).


=== debian/control ===
Source: mia
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Gert Wollny <gewo@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libblas-dev,
               libboost-filesystem-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-test-dev,
               libdcmtk-dev,
               libeigen3-dev,
               libfftw3-dev,
               libgsl-dev,
               libgts-dev,
               libitpp-dev,
               libhdf5-dev,
               libmaxflow-dev,
               libnifti2-dev,
               libnlopt-dev,
               libopenexr-dev,
               libpng-dev,
               libtiff-dev,
               libvtk9-dev (>= 9.5),
               libvistaio-dev,
               libxml2-dev,
               python3-lxml
Build-Depends-Indep: docbook-xsl,
                     doxygen,
                     graphviz,
                     libjs-mathjax,
                     xsltproc
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/mia
Vcs-Git: https://salsa.debian.org/med-team/mia.git
Homepage: https://mia.sourceforge.net

Package: libmia-2.4-4
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: library for 2D and 3D gray scale image processing
 libmia comprises a set of libraries and plug-ins for general purpose
 2D and 3D gray scale image processing and basic handling of triangular
 meshes. The libraries provide a basic infrastructure and  generic
 algorithms, that can be specialized by specifying the appropriate plug-ins.

Package: libmia-2.4-dev
Architecture: any
Section: libdevel
Depends: libmia-2.4-4 (= ${binary:Version}),
         mia-doctools (= ${source:Version}),
         libitpp-dev,
         libgsl-dev,
         libboost-test-dev,
         libfftw3-dev,
         libblas-dev,
         ${misc:Depends}
Recommends: libmia-2.4-doc
Description: library for 2D and 3D gray scale image processing, development files
 libmia comprises a set of libraries and plug-ins for general purpose
 2D and 3D gray scale image processing and basic handling of triangular
 meshes. The libraries provide a basic infrastructure and  generic
 algorithms, that can be specialized by specifying the appropriate plug-ins.
 This package provides the development files for the library.

Package: libmia-2.4-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-mathjax
Enhances: libmia-2.4-dev
Multi-Arch: foreign
Description: library for 2D and 3D gray scale image processing, documentation
 libmia comprises a set of libraries and plug-ins for general purpose
 2D and 3D gray scale image processing and basic handling of triangular
 meshes. The libraries provide a basic infrastructure and  generic
 algorithms, that can be specialized by specifying the appropriate plug-ins.
 This package provides the Doxygen generated API reference.

Package: mia-tools
Architecture: any
Depends: libmia-2.4-4 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: mia-tools-doc
#Suggests: python-nipype
Description: Command line tools for gray scale image processing
 Command lines tools to run general purpose image processing tasks on 2D
 and 3D gray scale images, and basic operations on triangular meshes.
 Supported image processing algorithms are image filtering, combining, image
 registration, motion compensation for image series, and the estimation of
 various statistics over images.
 This package also contains the nipype interfaces for these command line tools.

Package: mia-doctools
Architecture: all
Depends: python3-lxml,
         python3,
         ${misc:Depends}
Description: Helper scripts for run-time document creation
 A set of scripts that can be used to create man-pages and on-line
 documentation for programs that make use of the mia command line
 parser and plug-in infrastructure

Package: mia-tools-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Enhances: mia-tools
Multi-Arch: foreign
Description: Cross-referenced documentation of the MIA command line tools
 Cross referenced documentation of the command line tools and plug-ins that
 are provided by the MIA gray scale image processing tool chain.
 These lines tools to provide the means to run general purpose image
 processing tasks on 2D and 3D gray scale images, and basic operations on
 triangular meshes interactively from the command line. Supported image
 processing algorithms are image filtering, combining, image registration,
 motion compensation for image series, and the estimation of various
 statistics over images.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile-gmake -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_LDFLAGS_MAINT_APPEND = -fvisibility=hidden
export DEB_CPPFLAGS_MAINT_APPEND = -DH5Oget_info_by_name_vers=1 -DH5O_info_t_vers=1

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# deduce documentation option (build-indep target)
ifeq "" "$(filter %-doc,$(shell dh_listpackages))"
  BUILDDOC = OFF
else
  BUILDDOC = ON
endif


.PHONY: override_dh_strip override_dh_shlibdeps

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
	-DALWAYS_CREATE_DOC=$(BUILDDOC)  \
	-DSTRICT_DEPENDECIES=ON \
	-DMIA_CREATE_MANPAGES=ON \
	-DMIA_CREATE_USERDOC=$(BUILDDOC) \
	-DMIA_CREATE_NIPYPE_INTERFACES=OFF \
	-DCMAKE_SKIP_INSTALL_ALL_DEPENDENCY=OFF

override_dh_auto_test-indep: ;

# Skip some failing tests; variable definitions should be kept in sync
# with those at debian/tests/testsuite.
SKIP := 2d-imageio|2dmyocardsegset-io-xml|3d-vectorfield|3d-rigidregister|cmdlineparseroutput|cmdxmlhelp|fastica-implementation-fastica
ifeq ($(DEB_HOST_ARCH_BITS),32)
SKIP_32 := |2dimage-cost-lsd
endif
override_dh_auto_test-arch:
	dh_auto_test -- ARGS\+="--exclude-regex \"$(SKIP)$(SKIP_32)\""

# dh_strip detects executable files, so make *.mia files executable then strip then
# remove the executable flag
override_dh_strip:
	`pwd`/debian/run_strip

override_dh_auto_build-indep:
	dh_auto_build -- doc

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_install-indep:
	# Install process expects some files that are not built in arch all builds
	dh_auto_install -i || true
	find debian/*/usr/share/doc -name CMakeLists.txt -delete

override_dh_shlibdeps:
	dh_shlibdeps -- $(shell find  debian/libmia-2.4-4/ -name "*.mia")

override_dh_missing:
	find debian/tmp \( -name "*-doc.desktop" -o -name COPYING \) -delete
	dh_missing

=== debian/watch ===
Version: 5

Source: http://sf.net/mia/
Matching-Pattern: mia-([\d.]+)\.tar\.xz
Pgpsigurlmangle: s/$/.asc/
